Index: uspace/drv/char/i8042/main.c
===================================================================
--- uspace/drv/char/i8042/main.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/char/i8042/main.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -26,9 +26,7 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-
 /** @addtogroup drvi8042
  * @{
  */
-
 /** @file
  * @brief i8042 driver DDF bits.
@@ -43,100 +41,12 @@
 #include <ddf/log.h>
 #include <stdio.h>
+
 #include "i8042.h"
 
-#define CHECK_RET_RETURN(ret, message...) \
-	do { \
-		if (ret != EOK) { \
-			ddf_msg(LVL_ERROR, message); \
-			return ret; \
-		} \
-	} while (0)
+#define NAME "i8042"
 
-/** Get address of I/O registers.
- *
- * @param[in]  dev            Device asking for the addresses.
- * @param[out] io_reg_address Base address of the memory range.
- * @param[out] io_reg_size    Size of the memory range.
- * @param[out] kbd_irq        Primary port IRQ.
- * @param[out] mouse_irq      Auxiliary port IRQ.
- *
- * @return Error code.
- *
- */
-static int get_my_registers(const ddf_dev_t *dev, uintptr_t *io_reg_address,
-    size_t *io_reg_size, int *kbd_irq, int *mouse_irq)
-{
-	assert(dev);
-	
-	async_sess_t *parent_sess =
-	    devman_parent_device_connect(EXCHANGE_SERIALIZE, dev->handle,
-	    IPC_FLAG_BLOCKING);
-	if (!parent_sess)
-		return ENOMEM;
-	
-	hw_res_list_parsed_t hw_resources;
-	hw_res_list_parsed_init(&hw_resources);
-	const int ret = hw_res_get_list_parsed(parent_sess, &hw_resources, 0);
-	async_hangup(parent_sess);
-	if (ret != EOK)
-		return ret;
-	
-	if ((hw_resources.irqs.count != 2) ||
-	    (hw_resources.io_ranges.count != 1)) {
-		hw_res_list_parsed_clean(&hw_resources);
-		return EINVAL;
-	}
-	
-	if (io_reg_address)
-		*io_reg_address = hw_resources.io_ranges.ranges[0].address;
-	
-	if (io_reg_size)
-		*io_reg_size = hw_resources.io_ranges.ranges[0].size;
-	
-	if (kbd_irq)
-		*kbd_irq = hw_resources.irqs.irqs[0];
-	
-	if (mouse_irq)
-		*mouse_irq = hw_resources.irqs.irqs[1];
-	
-	hw_res_list_parsed_clean(&hw_resources);
-	return EOK;
-}
-
-/** Initialize a new ddf driver instance of i8042 driver
- *
- * @param[in] device DDF instance of the device to initialize.
- *
- * @return Error code.
- *
- */
-static int i8042_dev_add(ddf_dev_t *device)
-{
-	if (!device)
-		return EINVAL;
-	
-	uintptr_t io_regs = 0;
-	size_t io_size = 0;
-	int kbd = 0;
-	int mouse = 0;
-	
-	int ret = get_my_registers(device, &io_regs, &io_size, &kbd, &mouse);
-	CHECK_RET_RETURN(ret, "Failed to get registers: %s.",
-	    str_error(ret));
-	ddf_msg(LVL_DEBUG, "I/O regs at %p (size %zuB), IRQ kbd %d, IRQ mouse %d.",
-	    (void *) io_regs, io_size, kbd, mouse);
-	
-	i8042_t *i8042 = ddf_dev_data_alloc(device, sizeof(i8042_t));
-	ret = (i8042 == NULL) ? ENOMEM : EOK;
-	CHECK_RET_RETURN(ret, "Failed to allocate i8042 driver instance.");
-	
-	ret = i8042_init(i8042, (void *) io_regs, io_size, kbd, mouse, device);
-	CHECK_RET_RETURN(ret, "Failed to initialize i8042 driver: %s.",
-	    str_error(ret));
-	
-	ddf_msg(LVL_NOTE, "Controlling '%s' (%" PRIun ").",
-	    device->name, device->handle);
-	return EOK;
-}
+static int get_my_registers(const ddf_dev_t *dev,
+    uintptr_t *io_reg_address, size_t *io_reg_size, int *kbd, int *mouse);
+static int i8042_dev_add(ddf_dev_t *device);
 
 /** DDF driver operations. */
@@ -151,11 +61,107 @@
 };
 
+/** Initialize global driver structures (NONE).
+ *
+ * @param[in] argc Nmber of arguments in argv vector (ignored).
+ * @param[in] argv Cmdline argument vector (ignored).
+ * @return Error code.
+ *
+ * Driver debug level is set here.
+ */
 int main(int argc, char *argv[])
 {
-	printf("%s: HelenOS PS/2 driver.\n", NAME);
+	printf(NAME ": HelenOS ps/2 driver.\n");
 	ddf_log_init(NAME, LVL_NOTE);
 	return ddf_driver_main(&i8042_driver);
 }
 
+/** Initialize a new ddf driver instance of i8042 driver
+ *
+ * @param[in] device DDF instance of the device to initialize.
+ * @return Error code.
+ */
+static int i8042_dev_add(ddf_dev_t *device)
+{
+	if (!device)
+		return EINVAL;
+
+#define CHECK_RET_RETURN(ret, message...) \
+if (ret != EOK) { \
+	ddf_msg(LVL_ERROR, message); \
+	return ret; \
+} else (void)0
+
+	uintptr_t io_regs = 0;
+	size_t io_size = 0;
+	int kbd = 0, mouse = 0;
+
+	int ret = get_my_registers(device, &io_regs, &io_size, &kbd, &mouse);
+	CHECK_RET_RETURN(ret,
+	    "Failed to get registers: %s.", str_error(ret));
+	ddf_msg(LVL_DEBUG,
+	    "I/O regs at %p (size %zuB), IRQ kbd %d, IRQ mouse %d.",
+	    (void *) io_regs, io_size, kbd, mouse);
+
+	i8042_t *i8042 = ddf_dev_data_alloc(device, sizeof(i8042_t));
+	ret = (i8042 == NULL) ? ENOMEM : EOK;
+	CHECK_RET_RETURN(ret, "Failed to allocate i8042 driver instance.");
+
+	ret = i8042_init(i8042, (void*)io_regs, io_size, kbd, mouse, device);
+	CHECK_RET_RETURN(ret,
+	    "Failed to initialize i8042 driver: %s.", str_error(ret));
+
+	ddf_msg(LVL_NOTE, "Controlling '%s' (%" PRIun ").",
+	    device->name, device->handle);
+	return EOK;
+}
+
+/** Get address of I/O registers.
+ *
+ * @param[in] dev Device asking for the addresses.
+ * @param[out] io_reg_address Base address of the memory range.
+ * @param[out] io_reg_size Size of the memory range.
+ * @param[out] kbd_irq Primary port IRQ.
+ * @param[out] mouse_irq Auxiliary port IRQ.
+ * @return Error code.
+ */
+int get_my_registers(const ddf_dev_t *dev, uintptr_t *io_reg_address,
+    size_t *io_reg_size, int *kbd_irq, int *mouse_irq)
+{
+	assert(dev);
+
+	async_sess_t *parent_sess =
+	    devman_parent_device_connect(EXCHANGE_SERIALIZE, dev->handle,
+	    IPC_FLAG_BLOCKING);
+	if (!parent_sess)
+		return ENOMEM;
+
+	hw_res_list_parsed_t hw_resources;
+	hw_res_list_parsed_init(&hw_resources);
+	const int ret = hw_res_get_list_parsed(parent_sess, &hw_resources, 0);
+	async_hangup(parent_sess);
+	if (ret != EOK) {
+		return ret;
+	}
+
+	if (hw_resources.irqs.count != 2 || hw_resources.io_ranges.count != 1) {
+		hw_res_list_parsed_clean(&hw_resources);
+		return EINVAL;
+	}
+
+	if (io_reg_address)
+		*io_reg_address = hw_resources.io_ranges.ranges[0].address;
+
+	if (io_reg_size)
+		*io_reg_size = hw_resources.io_ranges.ranges[0].size;
+
+	if (kbd_irq)
+		*kbd_irq = hw_resources.irqs.irqs[0];
+
+	if (mouse_irq)
+		*mouse_irq = hw_resources.irqs.irqs[1];
+
+	hw_res_list_parsed_clean(&hw_resources);
+	return EOK;
+}
 /**
  * @}
Index: uspace/drv/char/ps2mouse/ps2mouse.c
===================================================================
--- uspace/drv/char/ps2mouse/ps2mouse.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/char/ps2mouse/ps2mouse.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -116,5 +116,5 @@
 	assert(mouse);
 	assert(dev);
-	mouse->client_sess = NULL;
+	mouse->input_sess = NULL;
 	mouse->parent_sess = devman_parent_device_connect(EXCHANGE_SERIALIZE,
 	    dev->handle, IPC_FLAG_BLOCKING);
@@ -218,8 +218,8 @@
 
 		async_exch_t *exch =
-		    async_exchange_begin(mouse->client_sess);
+		    async_exchange_begin(mouse->input_sess);
 		if (!exch) {
 			ddf_msg(LVL_ERROR,
-			    "Failed creating exchange.");
+			    "Failed to create input exchange.");
 			continue;
 		}
@@ -277,8 +277,8 @@
 
 		async_exch_t *exch =
-		    async_exchange_begin(mouse->client_sess);
+		    async_exchange_begin(mouse->input_sess);
 		if (!exch) {
 			ddf_msg(LVL_ERROR,
-			    "Failed creating exchange.");
+			    "Failed to create input exchange.");
 			continue;
 		}
@@ -386,14 +386,14 @@
 		if (sess == NULL) {
 			ddf_msg(LVL_WARN,
-			    "Failed creating client callback session");
+			    "Failed to create start input session");
 			async_answer_0(icallid, EAGAIN);
 			break;
 		}
-		if (mouse->client_sess == NULL) {
-			mouse->client_sess = sess;
-			ddf_msg(LVL_DEBUG, "Set client session");
+		if (mouse->input_sess == NULL) {
+			mouse->input_sess = sess;
+			ddf_msg(LVL_DEBUG, "Set input session");
 			async_answer_0(icallid, EOK);
 		} else {
-			ddf_msg(LVL_ERROR, "Client session already set");
+			ddf_msg(LVL_ERROR, "Input session already set");
 			async_answer_0(icallid, ELIMIT);
 		}
Index: uspace/drv/char/ps2mouse/ps2mouse.h
===================================================================
--- uspace/drv/char/ps2mouse/ps2mouse.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/char/ps2mouse/ps2mouse.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -43,5 +43,5 @@
 	ddf_fun_t *mouse_fun;      /**< Mouse function. */
 	async_sess_t *parent_sess; /**< Connection to device providing data. */
-	async_sess_t *client_sess;  /**< Callback connection to client. */
+	async_sess_t *input_sess;  /**< Callback connection to consumer. */
 	fid_t polling_fibril;      /**< Fibril retrieving an parsing data. */
 } ps2_mouse_t;
Index: uspace/drv/char/xtkbd/xtkbd.c
===================================================================
--- uspace/drv/char/xtkbd/xtkbd.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/char/xtkbd/xtkbd.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -206,5 +206,5 @@
 	assert(kbd);
 	assert(dev);
-	kbd->client_sess = NULL;
+	kbd->input_sess = NULL;
 	kbd->parent_sess = devman_parent_device_connect(EXCHANGE_SERIALIZE,
 	    dev->handle, IPC_FLAG_BLOCKING);
@@ -296,8 +296,8 @@
 		if (key != 0) {
 			async_exch_t *exch =
-			    async_exchange_begin(kbd->client_sess);
+			    async_exchange_begin(kbd->input_sess);
 			if (!exch) {
 				ddf_msg(LVL_ERROR,
-				    "Failed creating exchange.");
+				    "Failed to create input exchange.");
 				continue;
 			}
@@ -352,14 +352,14 @@
 		if (sess == NULL) {
 			ddf_msg(LVL_WARN,
-			    "Failed creating callback session");
+			    "Failed to create start input session");
 			async_answer_0(icallid, EAGAIN);
 			break;
 		}
-		if (kbd->client_sess == NULL) {
-			kbd->client_sess = sess;
-			ddf_msg(LVL_DEBUG, "Set client session");
+		if (kbd->input_sess == NULL) {
+			kbd->input_sess = sess;
+			ddf_msg(LVL_DEBUG, "Set input session");
 			async_answer_0(icallid, EOK);
 		} else {
-			ddf_msg(LVL_ERROR, "Client session already set");
+			ddf_msg(LVL_ERROR, "Input session already set");
 			async_answer_0(icallid, ELIMIT);
 		}
Index: uspace/drv/char/xtkbd/xtkbd.h
===================================================================
--- uspace/drv/char/xtkbd/xtkbd.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/char/xtkbd/xtkbd.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -43,5 +43,5 @@
 	ddf_fun_t *kbd_fun;        /**< Keyboard function. */
 	async_sess_t *parent_sess; /**< Connection to device providing data. */
-	async_sess_t *client_sess; /**< Callback connection to client. */
+	async_sess_t *input_sess;  /**< Callback connection to consumer. */
 	fid_t polling_fibril;      /**< Fibril retrieving an parsing data. */
 } xt_kbd_t;
Index: uspace/drv/nic/e1k/e1k.c
===================================================================
--- uspace/drv/nic/e1k/e1k.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/nic/e1k/e1k.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -52,4 +52,7 @@
 #include <nil_remote.h>
 #include <ops/nic.h>
+#include <packet_client.h>
+#include <packet_remote.h>
+#include <net/packet_header.h>
 #include "e1k.h"
 
@@ -59,13 +62,13 @@
 
 /* Must be power of 8 */
-#define E1000_RX_FRAME_COUNT  128
-#define E1000_TX_FRAME_COUNT  128
+#define E1000_RX_PACKETS_COUNT  128
+#define E1000_TX_PACKETS_COUNT  128
 
 #define E1000_RECEIVE_ADDRESS  16
 
-/** Maximum sending frame size */
+/** Maximum sending packet size */
 #define E1000_MAX_SEND_FRAME_SIZE  2048
-/** Maximum receiving frame size */
-#define E1000_MAX_RECEIVE_FRAME_SIZE  2048
+/** Maximum receiving packet size */
+#define E1000_MAX_RECEIVE_PACKET_SIZE  2048
 
 /** nic_driver_data_t* -> e1000_t* cast */
@@ -134,13 +137,11 @@
 	void *rx_ring_virt;
 	
-	/** Ring of RX frames, physical address */
-	void **rx_frame_phys;
-	/** Ring of RX frames, virtual address */
-	void **rx_frame_virt;
+	/** Packets in rx ring  */
+	packet_t **rx_ring_packets;
 	
 	/** VLAN tag */
 	uint16_t vlan_tag;
 	
-	/** Add VLAN tag to frame */
+	/** Add VLAN tag to packet */
 	bool vlan_tag_add;
 	
@@ -476,5 +477,5 @@
 }
 
-/** Get state of acceptance of weird frames
+/** Get state of acceptance of weird packets
  *
  * @param      device Device to check
@@ -494,5 +495,5 @@
 };
 
-/** Set acceptance of weird frames
+/** Set acceptance of weird packets
  *
  * @param device Device to update
@@ -678,5 +679,5 @@
 }
 
-/** Disable receiving frames for default address
+/** Disable receiving packets for default address
  *
  * @param e1000 E1000 data structure
@@ -690,5 +691,5 @@
 }
 
-/** Enable receiving frames for default address
+/** Enable receiving packets for default address
  *
  * @param e1000 E1000 data structure
@@ -750,5 +751,5 @@
 }
 
-/** Enable accepting of broadcast frames
+/** Enable accepting of broadcast packets
  *
  * @param e1000 E1000 data structure
@@ -762,5 +763,5 @@
 }
 
-/** Disable accepting of broadcast frames
+/** Disable accepting of broadcast packets
  *
  * @param e1000 E1000 data structure
@@ -798,5 +799,5 @@
 }
 
-/** Set multicast frames acceptance mode
+/** Set multicast packets acceptance mode
  *
  * @param nic      NIC device to update
@@ -852,5 +853,5 @@
 }
 
-/** Set unicast frames acceptance mode
+/** Set unicast packets acceptance mode
  *
  * @param nic      NIC device to update
@@ -910,5 +911,5 @@
 }
 
-/** Set broadcast frames acceptance mode
+/** Set broadcast packets acceptance mode
  *
  * @param nic  NIC device to update
@@ -995,5 +996,5 @@
 	if (vlan_mask) {
 		/*
-		 * Disable receiving, so that frame matching
+		 * Disable receiving, so that packet matching
 		 * partially written VLAN is not received.
 		 */
@@ -1062,7 +1063,7 @@
 }
 
-/** Fill receive descriptor with new empty buffer
- *
- * Store frame in e1000->rx_frame_phys
+/** Fill receive descriptor with new empty packet
+ *
+ * Store packet in e1000->rx_ring_packets
  *
  * @param nic    NIC data stricture
@@ -1073,9 +1074,22 @@
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
-	
+	packet_t *packet =
+	    nic_alloc_packet(nic, E1000_MAX_RECEIVE_PACKET_SIZE);
+	
+	assert(packet);
+	
+	*(e1000->rx_ring_packets + offset) = packet;
 	e1000_rx_descriptor_t *rx_descriptor = (e1000_rx_descriptor_t *)
 	    (e1000->rx_ring_virt + offset * sizeof(e1000_rx_descriptor_t));
 	
-	rx_descriptor->phys_addr = PTR_TO_U64(e1000->rx_frame_phys[offset]);
+	void *phys;
+	int rc =
+	    nic_dma_lock_packet(packet, E1000_MAX_RECEIVE_PACKET_SIZE, &phys);
+	
+	if (rc == EOK)
+		rx_descriptor->phys_addr = PTR_TO_U64(phys + packet->data_start);
+	else
+		rx_descriptor->phys_addr = 0;
+	
 	rx_descriptor->length = 0;
 	rx_descriptor->checksum = 0;
@@ -1141,10 +1155,10 @@
 }
 
-/** Receive frames
+/** Receive packets
  *
  * @param nic NIC data
  *
  */
-static void e1000_receive_frames(nic_t *nic)
+static void e1000_receive_packets(nic_t *nic)
 {
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
@@ -1153,5 +1167,5 @@
 	
 	uint32_t *tail_addr = E1000_REG_ADDR(e1000, E1000_RDT);
-	uint32_t next_tail = e1000_inc_tail(*tail_addr, E1000_RX_FRAME_COUNT);
+	uint32_t next_tail = e1000_inc_tail(*tail_addr, E1000_RX_PACKETS_COUNT);
 	
 	e1000_rx_descriptor_t *rx_descriptor = (e1000_rx_descriptor_t *)
@@ -1159,18 +1173,16 @@
 	
 	while (rx_descriptor->status & 0x01) {
-		uint32_t frame_size = rx_descriptor->length - E1000_CRC_SIZE;
+		uint32_t packet_size = rx_descriptor->length - E1000_CRC_SIZE;
 		
-		nic_frame_t *frame = nic_alloc_frame(nic, frame_size);
-		if (frame != NULL) {
-			memcpy(frame->data, e1000->rx_frame_virt[next_tail], frame_size);
-			nic_received_frame(nic, frame);
-		} else {
-			ddf_msg(LVL_ERROR, "Memory allocation failed. Frame dropped.");
-		}
+		packet_t *packet = *(e1000->rx_ring_packets + next_tail);
+		packet_suffix(packet, packet_size);
+		
+		nic_dma_unlock_packet(packet, E1000_MAX_RECEIVE_PACKET_SIZE);
+		nic_received_packet(nic, packet);
 		
 		e1000_fill_new_rx_descriptor(nic, next_tail);
 		
-		*tail_addr = e1000_inc_tail(*tail_addr, E1000_RX_FRAME_COUNT);
-		next_tail = e1000_inc_tail(*tail_addr, E1000_RX_FRAME_COUNT);
+		*tail_addr = e1000_inc_tail(*tail_addr, E1000_RX_PACKETS_COUNT);
+		next_tail = e1000_inc_tail(*tail_addr, E1000_RX_PACKETS_COUNT);
 		
 		rx_descriptor = (e1000_rx_descriptor_t *)
@@ -1213,5 +1225,5 @@
 {
 	if (icr & ICR_RXT0)
-		e1000_receive_frames(nic);
+		e1000_receive_packets(nic);
 }
 
@@ -1262,5 +1274,5 @@
 }
 
-/** Force receiving all frames in the receive buffer
+/** Force receiving all packets in the receive buffer
  *
  * @param nic NIC data
@@ -1335,9 +1347,9 @@
 static void e1000_initialize_rx_registers(e1000_t *e1000)
 {
-	E1000_REG_WRITE(e1000, E1000_RDLEN, E1000_RX_FRAME_COUNT * 16);
+	E1000_REG_WRITE(e1000, E1000_RDLEN, E1000_RX_PACKETS_COUNT * 16);
 	E1000_REG_WRITE(e1000, E1000_RDH, 0);
 	
 	/* It is not posible to let HW use all descriptors */
-	E1000_REG_WRITE(e1000, E1000_RDT, E1000_RX_FRAME_COUNT - 1);
+	E1000_REG_WRITE(e1000, E1000_RDT, E1000_RX_PACKETS_COUNT - 1);
 	
 	/* Set Broadcast Enable Bit */
@@ -1359,5 +1371,5 @@
 	
 	int rc = dmamem_map_anonymous(
-	    E1000_RX_FRAME_COUNT * sizeof(e1000_rx_descriptor_t),
+	    E1000_RX_PACKETS_COUNT * sizeof(e1000_rx_descriptor_t),
 	    AS_AREA_READ | AS_AREA_WRITE, 0, &e1000->rx_ring_phys,
 	    &e1000->rx_ring_virt);
@@ -1370,31 +1382,13 @@
 	    (uint32_t) PTR_TO_U64(e1000->rx_ring_phys));
 	
-	e1000->rx_frame_phys =
-	    calloc(E1000_RX_FRAME_COUNT, sizeof(void *));
-	e1000->rx_frame_virt =
-	    calloc(E1000_RX_FRAME_COUNT, sizeof(void *));
-	if (e1000->rx_frame_phys == NULL || e1000->rx_frame_virt == NULL) {
-		rc = ENOMEM;
-		goto error;
-	}
-	
-	size_t i;
-	void *frame_virt;
-	void *frame_phys;
-	
-	for (i = 0; i < E1000_RX_FRAME_COUNT; i++) {
-		rc = dmamem_map_anonymous(
-		    E1000_MAX_SEND_FRAME_SIZE, AS_AREA_READ | AS_AREA_WRITE,
-		    0, &frame_phys, &frame_virt);
-		if (rc != EOK)
-			goto error;
-		
-		e1000->rx_frame_virt[i] = frame_virt;
-		e1000->rx_frame_phys[i] = frame_phys;
-	}
+	e1000->rx_ring_packets =
+	    malloc(E1000_RX_PACKETS_COUNT * sizeof(packet_t *));
+	// FIXME: Check return value
 	
 	/* Write descriptor */
-	for (i = 0; i < E1000_RX_FRAME_COUNT; i++)
-		e1000_fill_new_rx_descriptor(nic, i);
+	for (unsigned int offset = 0;
+	    offset < E1000_RX_PACKETS_COUNT;
+	    offset++)
+		e1000_fill_new_rx_descriptor(nic, offset);
 	
 	e1000_initialize_rx_registers(e1000);
@@ -1402,25 +1396,4 @@
 	fibril_mutex_unlock(&e1000->rx_lock);
 	return EOK;
-	
-error:
-	for (i = 0; i < E1000_RX_FRAME_COUNT; i++) {
-		if (e1000->rx_frame_virt[i] != NULL) {
-			dmamem_unmap_anonymous(e1000->rx_frame_virt[i]);
-			e1000->rx_frame_virt[i] = NULL;
-			e1000->rx_frame_phys[i] = NULL;
-		}
-	}
-	
-	if (e1000->rx_frame_phys != NULL) {
-		free(e1000->rx_frame_phys);
-		e1000->rx_frame_phys = NULL;
-	}
-	
-	if (e1000->rx_frame_virt != NULL) {
-		free(e1000->rx_frame_virt);
-		e1000->rx_frame_phys = NULL;
-	}
-	
-	return rc;
 }
 
@@ -1434,28 +1407,27 @@
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
 	
-	/* Write descriptor */
-	for (unsigned int offset = 0; offset < E1000_RX_FRAME_COUNT; offset++) {
-		dmamem_unmap_anonymous(e1000->rx_frame_virt[offset]);
-		e1000->rx_frame_virt[offset] = NULL;
-		e1000->rx_frame_phys[offset] = NULL;
-	}
-	
-	free(e1000->rx_frame_virt);
-	free(e1000->rx_frame_phys);
-	e1000->rx_frame_virt = NULL;
-	e1000->rx_frame_phys = NULL;
-	dmamem_unmap_anonymous(e1000->rx_ring_virt);
-}
-
-/** Clear receive descriptor ring
- *
- * @param e1000 E1000 data
- *
- */
-static void e1000_clear_rx_ring(e1000_t *e1000)
-{
 	/* Write descriptor */
 	for (unsigned int offset = 0;
-	    offset < E1000_RX_FRAME_COUNT;
+	    offset < E1000_RX_PACKETS_COUNT;
+	    offset++) {
+		packet_t *packet = *(e1000->rx_ring_packets + offset);
+		nic_dma_unlock_packet(packet, E1000_MAX_RECEIVE_PACKET_SIZE);
+		nic_release_packet(nic, packet);
+	}
+	
+	free(e1000->rx_ring_packets);
+	dmamem_unmap_anonymous(e1000->rx_ring_virt);
+}
+
+/** Clear receive descriptor ring
+ *
+ * @param e1000 E1000 data
+ *
+ */
+static void e1000_clear_rx_ring(e1000_t *e1000)
+{
+	/* Write descriptor */
+	for (unsigned int offset = 0;
+	    offset < E1000_RX_PACKETS_COUNT;
 	    offset++)
 		e1000_clear_rx_descriptor(e1000, offset);
@@ -1526,5 +1498,5 @@
 static void e1000_initialize_tx_registers(e1000_t *e1000)
 {
-	E1000_REG_WRITE(e1000, E1000_TDLEN, E1000_TX_FRAME_COUNT * 16);
+	E1000_REG_WRITE(e1000, E1000_TDLEN, E1000_TX_PACKETS_COUNT * 16);
 	E1000_REG_WRITE(e1000, E1000_TDH, 0);
 	E1000_REG_WRITE(e1000, E1000_TDT, 0);
@@ -1558,5 +1530,5 @@
 	
 	int rc = dmamem_map_anonymous(
-	    E1000_TX_FRAME_COUNT * sizeof(e1000_tx_descriptor_t),
+	    E1000_TX_PACKETS_COUNT * sizeof(e1000_tx_descriptor_t),
 	    AS_AREA_READ | AS_AREA_WRITE, 0, &e1000->tx_ring_phys,
 	    &e1000->tx_ring_virt);
@@ -1565,8 +1537,8 @@
 	
 	bzero(e1000->tx_ring_virt,
-	    E1000_TX_FRAME_COUNT * sizeof(e1000_tx_descriptor_t));
-	
-	e1000->tx_frame_phys = calloc(E1000_TX_FRAME_COUNT, sizeof(void *));
-	e1000->tx_frame_virt = calloc(E1000_TX_FRAME_COUNT, sizeof(void *));
+	    E1000_TX_PACKETS_COUNT * sizeof(e1000_tx_descriptor_t));
+	
+	e1000->tx_frame_phys = calloc(E1000_TX_PACKETS_COUNT, sizeof(void *));
+	e1000->tx_frame_virt = calloc(E1000_TX_PACKETS_COUNT, sizeof(void *));
 
 	if (e1000->tx_frame_phys == NULL || e1000->tx_frame_virt == NULL) {
@@ -1575,5 +1547,5 @@
 	}
 	
-	for (i = 0; i < E1000_TX_FRAME_COUNT; i++) {
+	for (i = 0; i < E1000_TX_PACKETS_COUNT; i++) {
 		rc = dmamem_map_anonymous(
 		    E1000_MAX_SEND_FRAME_SIZE, AS_AREA_READ | AS_AREA_WRITE,
@@ -1600,5 +1572,5 @@
 	
 	if (e1000->tx_frame_phys != NULL && e1000->tx_frame_virt != NULL) {
-		for (i = 0; i < E1000_TX_FRAME_COUNT; i++) {
+		for (i = 0; i < E1000_TX_PACKETS_COUNT; i++) {
 			if (e1000->tx_frame_virt[i] != NULL) {
 				dmamem_unmap_anonymous(e1000->tx_frame_virt[i]);
@@ -1631,5 +1603,5 @@
 	size_t i;
 	
-	for (i = 0; i < E1000_TX_FRAME_COUNT; i++) {
+	for (i = 0; i < E1000_TX_PACKETS_COUNT; i++) {
 		dmamem_unmap_anonymous(e1000->tx_frame_virt[i]);
 		e1000->tx_frame_virt[i] = NULL;
@@ -1646,5 +1618,4 @@
 		e1000->tx_frame_phys = NULL;
 	}
-	
 	dmamem_unmap_anonymous(e1000->tx_ring_virt);
 }
@@ -1659,5 +1630,5 @@
 	/* Write descriptor */
 	for (unsigned int offset = 0;
-	    offset < E1000_TX_FRAME_COUNT;
+	    offset < E1000_TX_PACKETS_COUNT;
 	    offset++)
 		e1000_clear_tx_descriptor(nic, offset);
@@ -1716,5 +1687,5 @@
 }
 
-/** Activate the device to receive and transmit frames
+/** Activate the device to receive and transmit packets
  *
  * @param nic NIC driver data
@@ -2057,4 +2028,5 @@
 	case E1000_82545:
 	case E1000_82546:
+	case E1000_82572:
 		e1000->info.eerd_start = 0x01;
 		e1000->info.eerd_done = 0x10;
@@ -2063,5 +2035,4 @@
 		break;
 	case E1000_82547:
-	case E1000_82572:
 	case E1000_80003ES2:
 		e1000->info.eerd_start = 0x01;
@@ -2102,5 +2073,4 @@
 int e1000_dev_add(ddf_dev_t *dev)
 {
-	ddf_fun_t *fun;
 	assert(dev);
 	
@@ -2133,14 +2103,11 @@
 	e1000_initialize_vlan(e1000);
 	
-	fun = ddf_fun_create(nic_get_ddf_dev(nic), fun_exposed, "port0");
-	if (fun == NULL)
+	rc = nic_register_as_ddf_fun(nic, &e1000_dev_ops);
+	if (rc != EOK)
 		goto err_tx_structure;
-	nic_set_ddf_fun(nic, fun);
-	fun->ops = &e1000_dev_ops;
-	fun->driver_data = nic;
 	
 	rc = e1000_register_int_handler(nic);
 	if (rc != EOK)
-		goto err_fun_create;
+		goto err_tx_structure;
 	
 	rc = nic_connect_to_services(nic);
@@ -2165,24 +2132,10 @@
 		goto err_rx_structure;
 	
-	rc = ddf_fun_bind(fun);
-	if (rc != EOK)
-		goto err_fun_bind;
-	
-	rc = ddf_fun_add_to_category(fun, DEVICE_CATEGORY_NIC);
-	if (rc != EOK)
-		goto err_add_to_cat;
-	
 	return EOK;
 	
-err_add_to_cat:
-	ddf_fun_unbind(fun);
-err_fun_bind:
 err_rx_structure:
 	e1000_uninitialize_rx_structure(nic);
 err_irq:
 	unregister_interrupt_handler(dev, DRIVER_DATA_DEV(dev)->irq);
-err_fun_create:
-	ddf_fun_destroy(fun);
-	nic_set_ddf_fun(nic, NULL);
 err_tx_structure:
 	e1000_uninitialize_tx_structure(e1000);
@@ -2330,5 +2283,5 @@
 	
 	if (!descriptor_available) {
-		/* Frame lost */
+		/* Packet lost */
 		fibril_mutex_unlock(&e1000->tx_lock);
 		return;
@@ -2359,5 +2312,5 @@
 	
 	tdt++;
-	if (tdt == E1000_TX_FRAME_COUNT)
+	if (tdt == E1000_TX_PACKETS_COUNT)
 		tdt = 0;
 	
Index: uspace/drv/nic/e1k/e1k.h
===================================================================
--- uspace/drv/nic/e1k/e1k.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/nic/e1k/e1k.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -39,5 +39,5 @@
 #include <stdint.h>
 
-/** Ethernet CRC size after frame received in rx_descriptor */
+/** Ethernet CRC size after packet received in rx_descriptor */
 #define E1000_CRC_SIZE  4
 
@@ -109,5 +109,5 @@
 /** Transmit descriptor COMMAND field bits */
 typedef enum {
-	TXDESCRIPTOR_COMMAND_VLE = (1 << 6),   /**< VLAN frame Enable */
+	TXDESCRIPTOR_COMMAND_VLE = (1 << 6),   /**< VLAN Packet Enable */
 	TXDESCRIPTOR_COMMAND_RS = (1 << 3),    /**< Report Status */
 	TXDESCRIPTOR_COMMAND_IFCS = (1 << 1),  /**< Insert FCS */
Index: uspace/drv/nic/lo/lo.c
===================================================================
--- uspace/drv/nic/lo/lo.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/nic/lo/lo.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -42,4 +42,5 @@
 #include <async.h>
 #include <nic.h>
+#include <packet_client.h>
 
 #define NAME  "lo"
@@ -60,6 +61,17 @@
 static void lo_send_frame(nic_t *nic_data, void *data, size_t size)
 {
+	packet_t *packet;
+	int rc;
+
+	packet = nic_alloc_packet(nic_data, size);
+	if (packet == NULL)
+		return;
+
+	rc = packet_copy_data(packet, data, size);
+	if (rc != EOK)
+		return;
+
 	nic_report_send_ok(nic_data, 1, size);
-	nic_received_noneth_frame(nic_data, data, size);
+	nic_received_noneth_packet(nic_data, packet);
 }
 
@@ -80,61 +92,36 @@
 static int lo_dev_add(ddf_dev_t *dev)
 {
-	ddf_fun_t *fun = NULL;
-	bool bound = false;
-	
-	nic_t *nic = nic_create_and_bind(dev);
-	if (nic == NULL) {
+	nic_t *nic_data = nic_create_and_bind(dev);
+	if (nic_data == NULL) {
 		printf("%s: Failed to initialize\n", NAME);
 		return ENOMEM;
 	}
 	
-	dev->driver_data = nic;
-	nic_set_send_frame_handler(nic, lo_send_frame);
+	dev->driver_data = nic_data;
+	nic_set_send_frame_handler(nic_data, lo_send_frame);
 	
-	int rc = nic_connect_to_services(nic);
+	int rc = nic_connect_to_services(nic_data);
 	if (rc != EOK) {
 		printf("%s: Failed to connect to services\n", NAME);
-		goto error;
+		nic_unbind_and_destroy(dev);
+		return rc;
 	}
 	
-	fun = ddf_fun_create(nic_get_ddf_dev(nic), fun_exposed, "port0");
-	if (fun == NULL) {
-		printf("%s: Failed creating function\n", NAME);
-		rc = ENOMEM;
-		goto error;
+	rc = nic_register_as_ddf_fun(nic_data, &lo_dev_ops);
+	if (rc != EOK) {
+		printf("%s: Failed to register as DDF function\n", NAME);
+		nic_unbind_and_destroy(dev);
+		return rc;
 	}
-	nic_set_ddf_fun(nic, fun);
-	fun->ops = &lo_dev_ops;
-	fun->driver_data = nic;
 	
-	rc = nic_report_address(nic, &lo_addr);
+	rc = nic_report_address(nic_data, &lo_addr);
 	if (rc != EOK) {
 		printf("%s: Failed to setup loopback address\n", NAME);
-		goto error;
+		nic_unbind_and_destroy(dev);
+		return rc;
 	}
-	
-	rc = ddf_fun_bind(fun);
-	if (rc != EOK) {
-		printf("%s: Failed binding function\n", NAME);
-		goto error;
-	}
-	bound = true;
-	
-	rc = ddf_fun_add_to_category(fun, DEVICE_CATEGORY_NIC);
-	if (rc != EOK)
-		goto error;
 	
 	printf("%s: Adding loopback device '%s'\n", NAME, dev->name);
 	return EOK;
-	
-error:
-	if (bound)
-		ddf_fun_unbind(fun);
-	
-	if (fun != NULL)
-		ddf_fun_destroy(fun);
-	
-	nic_unbind_and_destroy(dev);
-	return rc;
 }
 
Index: uspace/drv/nic/ne2k/dp8390.c
===================================================================
--- uspace/drv/nic/ne2k/dp8390.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/nic/ne2k/dp8390.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -59,4 +59,6 @@
 #include <stdio.h>
 #include <libarch/ddi.h>
+#include <net/packet.h>
+#include <packet_client.h>
 #include "dp8390.h"
 
@@ -74,5 +76,5 @@
 	uint8_t status;
 	
-	/** Pointer to next frame */
+	/** Pointer to next packet */
 	uint8_t next;
 	
@@ -391,6 +393,6 @@
 	/*
 	 * Reset the transmit ring. If we were transmitting a frame,
-	 * we pretend that the frame is processed. Higher layers will
-	 * retransmit if the frame wasn't actually sent.
+	 * we pretend that the packet is processed. Higher layers will
+	 * retransmit if the packet wasn't actually sent.
 	 */
 	ne2k->sq.dirty = false;
@@ -446,5 +448,6 @@
 		return NULL;
 	
-	bzero(frame->data, length);
+	void *buf = packet_suffix(frame->packet, length);
+	bzero(buf, length);
 	uint8_t last = page + length / DP_PAGE;
 	
@@ -452,10 +455,10 @@
 		size_t left = (ne2k->stop_page - page) * DP_PAGE
 		    - sizeof(recv_header_t);
-		ne2k_download(ne2k, frame->data, page * DP_PAGE + sizeof(recv_header_t),
+		ne2k_download(ne2k, buf, page * DP_PAGE + sizeof(recv_header_t),
 		    left);
-		ne2k_download(ne2k, frame->data + left, ne2k->start_page * DP_PAGE,
+		ne2k_download(ne2k, buf + left, ne2k->start_page * DP_PAGE,
 		    length - left);
 	} else {
-		ne2k_download(ne2k, frame->data, page * DP_PAGE + sizeof(recv_header_t),
+		ne2k_download(ne2k, buf, page * DP_PAGE + sizeof(recv_header_t),
 		    length);
 	}
@@ -538,5 +541,5 @@
 		 * Update the boundary pointer
 		 * to the value of the page
-		 * prior to the next frame to
+		 * prior to the next packet to
 		 * be processed.
 		 */
@@ -581,5 +584,5 @@
 		fibril_mutex_lock(&ne2k->sq_mutex);
 		if (ne2k->sq.dirty) {
-			/* Prepare the buffer for next frame */
+			/* Prepare the buffer for next packet */
 			ne2k->sq.dirty = false;
 			ne2k->sq.size = 0;
Index: uspace/drv/nic/ne2k/dp8390.h
===================================================================
--- uspace/drv/nic/ne2k/dp8390.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/nic/ne2k/dp8390.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -264,4 +264,5 @@
 extern void ne2k_send(nic_t *, void *, size_t);
 extern void ne2k_interrupt(nic_t *, uint8_t, uint8_t);
+extern packet_t *ne2k_alloc_packet(nic_t *, size_t);
 
 extern void ne2k_set_accept_mcast(ne2k_t *, int);
Index: uspace/drv/nic/ne2k/ne2k.c
===================================================================
--- uspace/drv/nic/ne2k/ne2k.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/nic/ne2k/ne2k.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -261,5 +261,5 @@
 	/* Note: some frame with previous physical address may slip to NIL here
 	 * (for a moment the filtering is not exact), but ethernet should be OK with
-	 * that. Some frames may also be lost, but this is not a problem.
+	 * that. Some packet may also be lost, but this is not a problem.
 	 */
 	ne2k_set_physical_address((ne2k_t *) nic_get_specific(nic_data), address);
@@ -338,6 +338,4 @@
 static int ne2k_dev_add(ddf_dev_t *dev)
 {
-	ddf_fun_t *fun;
-	
 	/* Allocate driver data for the device. */
 	nic_t *nic_data = nic_create_and_bind(dev);
@@ -373,4 +371,10 @@
 	}
 	
+	rc = nic_register_as_ddf_fun(nic_data, &ne2k_dev_ops);
+	if (rc != EOK) {
+		ne2k_dev_cleanup(dev);
+		return rc;
+	}
+	
 	rc = nic_connect_to_services(nic_data);
 	if (rc != EOK) {
@@ -379,27 +383,4 @@
 	}
 	
-	fun = ddf_fun_create(nic_get_ddf_dev(nic_data), fun_exposed, "port0");
-	if (fun == NULL) {
-		ne2k_dev_cleanup(dev);
-		return ENOMEM;
-	}
-	nic_set_ddf_fun(nic_data, fun);
-	fun->ops = &ne2k_dev_ops;
-	fun->driver_data = nic_data;
-	
-	rc = ddf_fun_bind(fun);
-	if (rc != EOK) {
-		ddf_fun_destroy(fun);
-		ne2k_dev_cleanup(dev);
-		return rc;
-	}
-	
-	rc = ddf_fun_add_to_category(fun, DEVICE_CATEGORY_NIC);
-	if (rc != EOK) {
-		ddf_fun_unbind(fun);
-		ddf_fun_destroy(fun);
-		return rc;
-	}
-	
 	return EOK;
 }
